// clang -target x86_64-apple-macos -arch x86_64 -o hello_world hello_world.c -lcurses
// chmod u+x hello_world
// codesign --verbose=4 --timestamp --strict --options runtime -s "<YOUR SIGNING CERTIFICATE NAME>" hello_world --force

// Standard include
#include <stdio.h>
// For scanf()
#include <curses.h> 
// For strcmp()
#include <string.h>

// This is the evil check function which decides if we get access or not
int checkInput(char input[256]) {

  // The secret to check against the user input
  char hardcoded_string[] = "S3CR3T";

  // Compare the value of the variable "input" with the variable "hardcoded_string"
  return strcmp(input, hardcoded_string);
}

// The main function / entry point of the executable
int main(int argc, char **argv) {

  // Variable to hold the user input
  char input[256];

  // This msg will prompt the user to enter his / her secret
  printf("Enter your secret:\n");

  // Will wait for user input and store the input in the variable "input"
  scanf("%s", input);

  // Compare the value of the variable "input" with the variable "hardcoded_string"
  int result = checkInput(input); // strcmp(input, hardcoded_string);

  // If the compare of the two values succeeds (or not) show a appropriate message
  if (result == 0) {
    printf("SUCCESS\n");
  } else {
    printf("ERROR\n");
  }
  return 0;
}